package javaapplication1;
import java.util.ArrayList;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner ulaz = new Scanner(System.in);
        // N je koliko je puta nasao plazme 
        long N;
        N = ulaz.nextLong();
        // Q je broj pitanja i broj koliko je puta prestala da jede
        long Q;
        Q = ulaz.nextLong();
        // lista1 sadrzi koje dane je ovaj kupio
        ArrayList<Integer> lista1 = new ArrayList();
        // lista2 sadrzi koliko pitanja ima ovaj i kad je ova prekinula da jede
        ArrayList<Long> lista2 = new ArrayList();
        // ova lista je koliko plazme ima
        ArrayList<Integer> lista3 = new ArrayList();
        for(long i = 0; i<N;i++) {
            lista1.add(ulaz.nextInt());
            lista3.add(ulaz.nextInt());
        }
        for(long i = 0 ; i<Q;i++) {
            lista2.add(ulaz.nextLong());
        }
        for(int i = 0; i<Q;i++) {
            int j = 0;
            long zDan = lista2.get(i), plazma = 0, sd = 0;
            for(long dan = 1; dan<=zDan;dan++) {
               while(j <lista1.size() && dan == lista1.get(j) ) {
                  plazma+=lista3.get(j);
                  j++;
               }
                if(plazma>0) {
                   plazma--;
                   sd++;
                }
        }
            System.out.println(sd);
}
}
}